// This is a simple demo script, feel free to edit or delete it
// Find a tutorial and the list of availalbe elements at:
// https://www.pcibex.net/documentation/

PennController.ResetPrefix(null) // Shorten command names (keep this line here)

// Show the 'intro' trial first, then all the 'experiment' trials in a random order
// then send the results and finally show the trial labeled 'bye'
Sequence( "consent", "intro", "exintro", "example", "postex", randomize("experiment"), "demog", SendResults() , "bye" )


// What is in Header happens at the beginning of every single trial
Header(
    // We will use this global Var element later to store the participant's name
    newVar("ParticipantName")
        .global()
    ,
    // Delay of 250ms before every trial
    newTimer(250)
        .start()
        .wait()
)
.log( "PROLIFIC_ID" , GetURLParameter("id") )
.log( "STUDY_ID" , GetURLParameter("study") )
.log( "SESSION_ID" , GetURLParameter("session") )
// This log command adds a column reporting the participant's name to every line saved to the results


newTrial("consent",
    newText('consent', '<h3 style="text-align: center;">Beleegyezési nyilatkozat az IRB-FY2022-5933-as számú kísérlethez</h3><p>A kísérlet célja a magyar nyelv alaposabb megismerése. A kísérletet Guy Tabachnick végzi, doktori disszertációjának részeként. A kísérletet Maria Gouskova, egyetemi docens felügyeli.</p><p>A kísérlet az alábbi feladatokat foglalja magában:</p><ul><li>Valós vagy kitalált magyar szavak értékelése, megítélése vagy/és e szavaknak a magyar nyelvi szabályoknak megfelelő ragozása</li><li>Kérdőív kitöltése (életkor, nem, stb.).</li></ul><p>A kísérletben való részvételért 20–30 percet vesz igénybe. A kísérlet a mindennapi élettel járó természetés rizikót meghaladó kockázattal nem jár.</p><p>Míg Ön részére a kísérletben való részvétel nem jár közvetlen előnnyel, részvételével elősegíti a magyar nyelv alaposabb megismerését. A kísérletben való részvételért ellenszolgáltatásként 4 dollart fog kapni.</p><p>A kísérlet során semmiféle beazonosítható vagy védettséget élvező információ szolgáltatására nem kérjük meg.  A kísérlet során szolgáltatott adatok jövőbeni kutatások céljára szabadon felhasználhatók.</p><p>A kísérletben való részvétel önkéntes. Hozzájárulását bármikor következmények nélkül megtagadhatja vagy visszavonhatja. A kérdőív kitöltése során bármelyik kérdést kihagyhatja.</p><p>Ha a kísérlettel kapcsolatban valamit nem ért, vagy a tanulmánnyal kapcsolatban kérdése vagy észevétele van, forduljon Guy Tabachnickhoz (<a href="mailto:guyt@nyu.edu">guyt@nyu.edu</a>, 10 Washington Place, NY, New York, 10003, Egyesült Államok) vagy Maria Gouskovához (+1 212 998 7950, <a href="mailto:maria.gouskova@nyu.edu">maria.gouskova@nyu.edu</a>, 10 Washington Place, NY, New York, 10003, Egyesült Államok).</p><p>A kísérlet résztvevőinek általános jogairól az <em>NYU University Committee on Activities Involving Human Subjects (UCAIHS)</em>-nál tájékozódhat (New York University, 665 Broadway, Suite 804, New York, New York, 10012, <a href="mailto:ask.humansubjects@nyu.edu">ask.humansubjects@nyu.edu</a>, +1 212 998-4808). Ha hozzájuk fordul, kérem hivatkozzon a tanulmány sorszámára (IRB-FY2022-5933).</p>')
        .settings.center() // .css("text-align","center")
        .print()
    ,
    newButton("conscont", "Folytatás")
        .settings.center()
        .print()
        .wait()
)

newTrial("intro",
    newText('intro', "<p>Ebben a kísérletben olyan mondatokat mutatunk Önnek, amelyben kitalált magyar szavak vannak. Arra kérjük, próbálja meg kiejteni az aláhúzott szavakat, majd osztályozza őket egy 1-től 5-ig terjedő skálán az alapján, hogy mennyire hangzanak magyarosnak. Ha az adott szó nagyon furcsán hangzik és egyáltalán nem is érződik magyarnak, kérjük, adjon neki 1-est (nyomja meg az 1-es gombot). Ha azonban Ön szerint a szó Ön szerint akár lehetne egy magyar szó is, akkor adjon neki 5-öst (nyomja meg az 5-ös gombot). A következő oldalon bemutatunk egy példamondatot.</p><p>Jelen esetben az Ön első reakciója a fontos számunkra, ezért kérjük, hogy ne gondolkozzon sokáig azon, hogy vajon mi lehet a szó „helyes” kiejtése.</p>")
        .settings.center() // .css("text-align","center")
        .print()
    ,
    newButton("introcont", "Folytatás")
        .settings.center()
        .print()
        .wait()
//    newTextInput()
//        .print()
//        .wait()                 // The next command won't be executed until Enter is pressed
//        .setVar( "ParticipantName" )
//        // This setVar command stores the value from the TextInput element into the Var element
)

newTrial("exintro",
    newText('exintro', "<p>A következő oldalon megadott példamondatunkban a <em>bládut</em> szót fogjuk használni.</p><p>Amikor egy korábbi kísérletben magyar anyanyelvi beszélőket kérdeztünk a <i>bládut</i> szóról, legtöbben 5-öst adtak neki, jelezve, hogy az akár lehetne egy valós magyar szó is, csak ők még nem találkoztak vele.</p>")
        .settings.center()
        .print()
    ,
    newButton("exicont", "Folytatás")
        .settings.center()
        .print()
        .wait()
)

newTrial("example",
    newText('example', "<p>Ez a <b><u>bládut</u></b> egyike a leggyorsabban növekvő török <b><u>bládutoknak</u></b>.</p><p>Lehetnének-e az aláhúzott szavak magyarok?</p>")
        .settings.center()
        .css("text-align", "center")
        .print()
    ,
    newScale("exeval", "1","2","3","4","5")
        .labelsPosition("top")
        .before(newText('exnem', "nem")
                .cssContainer({height:'100%',display:'flex','flex-direction':'column'})
                .css("margin-top","auto")
            )
        .after(newText('exigen', "igen")
                .cssContainer({height:'100%',display:'flex','flex-direction':'column'})
                .css("margin-top","auto")
            )
        .settings.center()
        .print()
        .wait()
        .log()
    ,
    newCanvas("whitespace", 1, 25)
        .print()
    ,
    newButton("excont", "Folytatás")
        .settings.center()
        .print()
        .wait()
)

newTrial("postex",
    newText('postex', "<p>Most, hogy látta a példát, kezdjük el a kísérletet!</p>")
        .settings.center()
        .print()
    ,
    newButton("pexcont", "Folytatás")
        .settings.center()
        .print()
        .wait()
)

words = []

// This Template command creates a list of nonce words from stim_norm_wugs.csv to place into the frame sentences (below)
Template("stim_norm_wugs.csv",
    // a bit hacky, why can't I just push the whole row?
    row => newTrial("dummy",
        words.push({word: row.word, vowel: row.vowel, harmony: row.harmony, mid_pl: row.mid_pl, low_pl: row.low_pl, v_init: row.v_init=='TRUE'}),
        fisherYates(words),
        non_fu = words.slice(-50).filter(w => w.harmony != "fu"),
        fisherYates(non_fu),
        low = non_fu.slice(0,8)
    )
)

Template("stim_norm_sents.csv",
    row => newTrial( "experiment",
    wd = words.pop(),
    ht = low.includes(wd) ? 'low' : 'mid',
    newText('trial', "<p>" 
        + row.sentence
            .replace(' _s_', wd.v_init ? (row.art1)+' _s_' : ' _s_')
            .replace(' _p_', wd.v_init ? (row.art2)+' _p_' : ' _p_')
            .replace('_s_', "<b><u>"+wd.word+"</b></u>")
            .replace('_p_', "<b><u>"+wd.word+wd[ht+"_pl"]+row["suff2_"+wd.harmony]+"</b></u>")
        + "</p><p>Lehetnének-e az aláhúzott szavak magyarok?</p>")
        .settings.center()
        .css("text-align", "center")
        .print()
    ,
    newScale("eval", "1","2","3","4","5")
        .labelsPosition("top")
        .before(newText('nem', "nem")
                .cssContainer({height:'100%',display:'flex','flex-direction':'column'})
                .css("margin-top","auto")
            )
        .after(newText('igen', "igen")
                .cssContainer({height:'100%',display:'flex','flex-direction':'column'})
                .css("margin-top","auto")
            )
        .settings.center()
        .print()
        .wait()
        .log()
    ,
    newCanvas("whitespace", 1, 25)
        .print()
    ,
    newButton("trialcont", "Folytatás")
        .settings.center()
        .print()
        .wait()
    )
    .log("word", wd.word)
    .log("vowel", wd.vowel)
    .log("harmony", wd.harmony)
    .log("height", ht)
    .log("sentence", row.sentence)
    .log("suff2", row.suff2_b)
)

newTrial("demog",
    newText('demtext', "<p>Most már csak pár statisztikai célt szolgáló kérdés van hátra:</p>")
        .settings.center()
        .print()
    ,
    newText("aget", "Életkora:"),
    newText("gendert", "Neme:"),
    newText("bornt", "Magyarországon született?"),
    newText("born2t", "Ha nem, hol született?"),
    newText("huspeakt", "Gyerekkora óta magyarul beszél?"),
    newText("regiont", "Magyarország melyik részén nőtt fel?"),
    newText("educt", "Iskolai végzettsége:"),
    newTextInput("agei", "")
        .lines(1)
        .size(40,20)
        .log()
    ,
    newTextInput("genderi", "")
        .lines(1)
        .size(100,20)
        .log()
    ,
    newScale("borni", "igen", "nem")
        .labelsPosition("right")
        .log()
    ,
    newTextInput("born2i", "")
        .lines(1)
        .size(100,20)
        .log()
    ,
    newScale("huspeaki", "igen", "nem")
        .labelsPosition("right")
        .log()
    ,
    newTextInput("regioni", "")
        .lines(1)
        .size(100,20)
        .log()
    ,
    newTextInput("educi", "")
        .lines(1)
        .size(100,20)
        .log()
    ,
    newCanvas("age", 450, 20)
        .settings.center()
        .settings.add(0, 0, getText("aget"))
        .settings.add(350, 0, getTextInput("agei"))
        .print()
    ,
    newButton("agec", "Folytatás")
        .settings.center()
        .print()
        .wait( getTextInput("agei").test.text(/.*\w+.*/) )
        .remove()
    ,
    newCanvas("gender", 450, 40)
        .settings.center()
        .settings.add(0, 0, getText("gendert"))
        .settings.add(350, 0, getTextInput("genderi"))
        .print()
    ,
    newButton("genderc", "Folytatás")
        .settings.center()
        .print()
        .wait( getTextInput("genderi").test.text(/.*\w+.*/) )
        .remove()
    ,
    newCanvas("born", 450, 20)
        .settings.center()
        .settings.add(0, 0, getText("bornt"))
        .settings.add(350, 0, getScale("borni"))
        .print()
    ,
    newButton("bornc", "Folytatás")
        .settings.center()
        .print()
        .wait( getScale("borni").test.selected() )
        .remove()
    ,
    newCanvas("born2", 450, 40)
        .settings.center()
        .settings.add(0, 0, getText("born2t"))
        .settings.add(350, 0, getTextInput("born2i"))
        .print()
    ,
    newButton("born2c", "Folytatás")
        .settings.center()
        .print()
        .wait()
        .remove()
    ,
    newCanvas("huspeak", 450, 40)
        .settings.center()
        .settings.add(0, 0, getText("huspeakt"))
        .settings.add(350, 0, getScale("huspeaki"))
        .print()
    ,
    newButton("huspeakc", "Folytatás")
        .settings.center()
        .print()
        .wait( getScale("huspeaki").test.selected() )
        .remove()
    ,
    newCanvas("region", 450, 40)
        .settings.center()
        .settings.add(0, 0, getText("regiont"))
        .settings.add(350, 0, getTextInput("regioni"))
        .print()
    ,
    newButton("regionc", "Folytatás")
        .settings.center()
        .print()
        .wait( getTextInput("regioni").test.text(/.*\w+.*/) )
        .remove()
    ,
    newCanvas("educ", 450, 40)
        .settings.center()
        .settings.add(0, 0, getText("educt"))
        .settings.add(350, 0, getTextInput("educi"))
        .print()
    ,
    newButton("educc", "Folytatás")
        .settings.center()
        .print()
        .wait( getTextInput("educi").test.text(/.*\w+.*/) )
        .remove()
)


// Spaces and linebreaks don't matter to the script: we've only been using them for the sake of readability
newTrial( "bye" ,
    newText("Köszönjük részvetélét. Az alabbiakban megadjuk a Prolific URL-t: <a href=https://app.prolific.co/submissions/complete?cc=96ED12D7>https://app.prolific.co/submissions/complete?cc=96ED12D7</a>")
        .css("text-align", "center")
        .print()
    ,
    newButton().wait()  // Wait for a click on a non-displayed button = wait here forever
)
.setOption( "countsForProgressBar" , false )
// Make sure the progress bar is full upon reaching this last (non-)trial
